#include "clavierazerty.h"
#include "ui_clavierazerty.h"
#include <QFont>

//_________________________________________________________________________________
ClavierAzerty::ClavierAzerty(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ClavierAzerty)
{
    ui->setupUi(this);
    destination = NULL;         // par de destination;
    // mise en forme des touches
    setLayout(ui->gridLayout);
    // création des boutons
    keysTitle<<"a"<<"z"<<"e"<<"r"<<"t"<<"y"<<"u"<<"i"<<"o"<<"p"<<"del"<<"1"<<"2"<<"3"
             <<"q"<<"s"<<"d"<<"f"<<"g"<<"h"<<"j"<<"k"<<"l"<<"m"<<"enter"<<"4"<<"5"<<"6"
             <<"w"<<"x"<<"c"<<"v"<<"b"<<"n"<<","<<";"<<"."<<"@"<<"$"<<"7"<<"8"<<"9"
             <<"'"<<"#"<<"$"<<"*"<<" "<<"%"<<"!"<<"?"<<"/"<<"*"<<"-"<<"0"<<"+";
    QFont font("Arial", 10);
    for (int i=0, j=0; i<(int)keysTitle.size(); i++){ // les boutons numériques
                        QPushButton *b =new QPushButton(this);
                        b->setFont(font);
                        b->setMinimumSize(QSize(50,50));
                        b->setMaximumSize(QSize(100,100));
                        b->setObjectName("button"+keysTitle[i]);
                        b->setText(keysTitle[i]);
                        // enter prend deux cases du gridLayout
                        if (i==46){
                                    ui->gridLayout->addWidget(b, i/14+j, i%14+j, 1,2);
                                    j=1;
                                    }
                            else ui->gridLayout->addWidget(b, i/14, i%14+j);
                        buttons.push_back(b);
                        connect(b, SIGNAL(pressed()), this, SLOT(clickKey()));
                        }
}

//___________________________________________________________________________________
void ClavierAzerty::setObject(QLineEdit *lineEdit){
    if (lineEdit) this->destination = lineEdit;
}

//___________________________________________________________________________________
// une touche a été clickée
void ClavierAzerty::clickKey(){
    // y a t'il un lineedit valide attaché à ce clavier
    if (!destination) return;
    int i;
    QString br;             // une chaîne
    // quelle touche ?
    for (i=0 ; i<(int)buttons.size() && !buttons[i]->isDown() ; i++);
    // c'est la ième
    if (buttons[i]->text()=="clr") this->destination->setText("");
            else if (buttons[i]->text()=="del")destination->setText((br = destination->text()).remove(br.size()-1,1));
                else if (buttons[i]->text()=="enter") hide();
                    else  this->destination->setText(destination->text()+keysTitle[i]);
}

//___________________________________________________________________________________
ClavierAzerty::~ClavierAzerty()
{
    delete ui;
}
